#!/usr/local/bin/python

import sys
import os
# fix symbolic link
#sys.path.insert(0,os.path.dirname(os.path.abspath(sys.argv[0])))
try:
    from optparse import OptionParser
except ImportError:
    from BitQueue.optparse import OptionParser
from BitQueue import version

parser = OptionParser(usage='btqueue.py [-r|--root_path path] scheduler|crawler|remote|query|add [args...]',
                      version=version)
parser.add_option("-r","--root",dest="root_path",default=None,
                  help="specify root path")
parser.add_option("-d","--debug_level",dest="debug_level",default=1,
                  type='int',
                  help="specify debug level")
parser.add_option("-t","--test_crawler",dest="test_crawler",default=0,
                  action='store_true',
                  help="turn on crawler test mode")

def usage():
    print 'btqueue.py [scheduler|crawler|daemon|remote|query|add] [args...]'
    sys.exit()

if __name__ == '__main__':
    (options,args) = parser.parse_args()

    if len(args) == 0:
        parser.error('incorrect number of arguments')

    command = args[0]

    if sys.platform == 'win32' or not os.environ.get('HOME'):
        root_path = os.path.dirname(os.path.abspath(sys.argv[0]))
    else:
        root_path = os.path.join(os.environ.get('HOME'),'.btqueue')

#    if len(sys.argv) == 3:
#        root_path = sys.argv[2]
    root_path = options.root_path or root_path

    from BitQueue import policy
    pol = policy.Policy(root_path)
    pol.set_default()
    if options.debug_level >= 0:
        pol.update('debug_level',options.debug_level)

    if command == 'scheduler':
        from BitQueue.manager import Console
        app = Console()
        try:
            app.mainloop()
        except SystemExit:
            pass
        except Exception,why:
            print why
    elif command == 'daemon':
        from BitQueue.manager import Daemon
        app = Daemon()
        try:
            app.daemonize()
        except SystemExit:
            pass
        except Exception,why:
            print why
    elif command == 'remote':
        from BitQueue.manager import XMLRPCConsole
        app = XMLRPCConsole()
        try:
            app.mainloop()
        except SystemExit:
            pass
        except Exception,why:
            print why
    elif command == 'crawler':
        from BitCrawler.crawler import Crawler
        app = Crawler(options.test_crawler)
        app.process()
    else:
        from BitQueue.webservice import WebInterface
        app = WebInterface()
        from BitQueue import timeoutsocket
        timeoutsocket.setDefaultSocketTimeout(2)
        ret = app.process(command,sys.argv[2:])
        timeoutsocket.setDefaultSocketTimeout(None)
        if sys.platform == 'win32' and command=='add' and ret:
            if ret.find('timeout') >= 0: 
                from BitQueue.manager import NewConsole as Console
                app = Console()
                app.do_add(' '.join(sys.argv[2:]))
                app.mainloop()
            else:
                raw_input()
        elif command=='query' and type(ret)==type([]):
            for item in ret:
                print '%(Title)s\n\t%(Progress)6s %(DL Speed)9s %(UL Speed)9s %(#Seeds)6s %(#Peers)6s %(BT Status)-10s' % item
        elif type(ret)!=type([]):       #must be an error
            print ret
        else:
            pass
